﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using Syncfusion.Pdf.Graphics;
using System.IO;
using System.Diagnostics;
using System.Drawing;
using Syncfusion.Pdf.Interactive;
using System.Security.Cryptography.X509Certificates;

namespace DigitalSignatureSample
{
    class Program
    {
        static void Main(string[] args)
        {
            //Load PDF document 
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument("../../Data/Siganture_Field.pdf");

            //Gets the first page of the document
            PdfLoadedPage page = loadedDocument.Pages[0] as PdfLoadedPage;

            //Gets the first signature field of the PDF document
            PdfLoadedSignatureField signatureField1 = loadedDocument.Form.Fields[0] as PdfLoadedSignatureField;

            //Creates a certificate
            PdfCertificate certificate1 = new PdfCertificate("../../Data/PDF.pfx", "syncfusion");

            signatureField1.Signature = new PdfSignature(loadedDocument, page, certificate1, "Signature", signatureField1);
            signatureField1.Signature.DocumentPermissions = PdfCertificationFlags.AllowComments | PdfCertificationFlags.AllowFormFill | PdfCertificationFlags.ForbidChanges;

            //Draw image
            PdfBitmap signatureImage = new PdfBitmap("../../Data/logo.png");
            signatureField1.Signature.Appearance.Normal.Graphics.DrawImage(signatureImage, 0, 0, 90, 20);

            //Save the document into stream
            MemoryStream stream = new MemoryStream();
            loadedDocument.Save(stream);
            loadedDocument.Close(true);

            //Load the signed PDF document
            PdfLoadedDocument signedDocument = new PdfLoadedDocument(stream);

            //Load the PDF page
            PdfLoadedPage loadedPage = signedDocument.Pages[0] as PdfLoadedPage;

            //Gets the first signature field of the PDF document
            PdfLoadedSignatureField signatureField2 = signedDocument.Form.Fields[1] as PdfLoadedSignatureField;
            signatureField2.Signature = new PdfSignature(signedDocument, loadedPage, certificate1, "Signature", signatureField2);
            signatureField2.Signature.DocumentPermissions = PdfCertificationFlags.AllowComments | PdfCertificationFlags.AllowFormFill | PdfCertificationFlags.ForbidChanges;

            //Draw image
            signatureField2.Signature.Appearance.Normal.Graphics.DrawImage(signatureImage, 0, 0, 90, 20);

            signedDocument.Save("Sample.pdf");
            signedDocument.Close(true);

            Process.Start("Sample.pdf");
        }     
    }
}
